<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />

    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <style>
      th {
        background-color: #5b9ad4;
        color: white;
      }

      table {
        background-color: #d3dfef;
      }

      tr:nth-child(even) {
        background-color: #eaeef6;
      }

      th,
      td {
        border: 1px solid white;
      }
    </style>
  </head>
  <body>
    <div class="container-fluid">
      <h3 class="text-center my-3" style="color: #2f5272;">DANH SÁCH ĐƠN HÀNG</h3>
      <table class="table" id="order-table">
        <thead>
          <th scope="col">STT</th>
          <th scope="col">Mã đơn hàng</th>
          <th scope="col">Họ và tên</th>
          <th scope="col">Payment method</th>
          <th scope="col">
            Số lượng<br />
            sản phẩm
          </th>
          <th scope="col">Tổng tiền</th>
          <th scope="col">Ngày đặt hàng</th>
          <th scope="col">Action</th>
        </thead>
        <tbody></tbody>
      </table>
    </div>

    <!-- Modal update -->
    <div id="update-order-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-body px-5">
            <h5 class="modal-tittle text-center my-4" id="h5-modal-tittle">
              CHI TIẾT ĐƠN HÀNG - MÃ: RGEELP
            </h5>
            <form action="">
              <div class="row">
                <div class="col-md-6">
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4 p-0"
                      >Họ và đệm <span class="text-danger">(*)</span></label
                    >
                    <div class="col-sm-8">
                      <input
                        type="text"
                        id="input-update-ho-dem"
                        class="form-control"
                      />
                    </div>
                  </div>

                  <div class="row form-group">
                    <label class="col-form-label col-sm-4 p-0"
                      >Email <span class="text-danger">(*)</span></label
                    >
                    <div class="col-sm-8">
                      <input
                        type="text"
                        id="input-update-email"
                        class="form-control"
                      />
                    </div>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4 p-0 pl-5"
                      >Tên <span class="text-danger">(*)</span></label
                    >
                    <div class="col-sm-8">
                      <input
                        type="text"
                        id="input-update-ten"
                        class="form-control"
                      />
                    </div>
                  </div>

                  <div class="row form-group">
                    <label class="col-form-label col-sm-4 p-0 pl-5"
                      >Phone <span class="text-danger">(*)</span></label
                    >
                    <div class="col-sm-8">
                      <input
                        type="text"
                        id="input-update-phone"
                        class="form-control"
                      />
                    </div>
                  </div>
                </div>
              </div>

              <div class="row form-group">
                <label class="col-form-label col-sm-2 p-0"
                  >Address <span class="text-danger">(*)</span></label
                >
                <div class="col-sm-10">
                  <input
                    type="text"
                    id="input-update-address"
                    class="form-control"
                  />
                </div>
              </div>

              <div class="row">
                <div class="col-md-6">
                  <div class="row form-group">
                    <label class="col-form-label col-sm-5 p-0"
                      >Payment Method
                      <span class="text-danger">(*)</span></label
                    >
                    <div class="col-sm-7">
                      <select
                        class="form-control"
                        id="select-update-payment-method"
                      >
                        <option value="Paypal">Paypal</option>
                        <option value="CreditCard">Credit Card</option>
                        <option value="BankTransfer">Bank Transfer</option>
                      </select>
                    </div>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4 p-0 pl-4"
                      >Mã giảm giá</label
                    >
                    <div class="col-sm-8">
                      <input
                        type="text"
                        id="input-update-ma-giam-gia"
                        class="form-control"
                      />
                      <p class="font-italic">
                        (Được giảm
                        <span
                          id="span-update-phan-tram-giam-gia"
                          class="font-weight-bold"
                          >0%</span
                        >)
                      </p>
                    </div>
                  </div>
                </div>
              </div>
            </form>

            <div class="text-right mb-4">
              <button
                class="btn btn-secondary mr-2"
                id="btn-update-cancel"
                data-dismiss="modal"
              >
                Hủy
              </button>
              <button class="btn btn-success" id="btn-update-order">
                Cập nhật
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
      <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="h5-modal-title">
                Confirm xóa order
              </h5>
              <button class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
              <label>Bạn có chắc chắn muốn xóa order này không?</label>
            </div>
            <div class="modal-footer">
              <button class="btn btn-danger" id="btn-confirm-delete-user">
                Xác nhận
              </button>
              <button class="btn btn-secondary" data-dismiss="modal">
                Hủy bỏ
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
</html>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gBASE_URL = "https://food-ordering-fvo9.onrender.com/api";

  const gORDER_COLS = [
    "stt",
    "orderCode",
    "id",
    "methodPayment",
    "foods",
    "foods",
    "createdAt",
    "action",
  ];

  const gSTT_COL = 0;
  const gMADH_COL = 1;
  const gHO_TEN_COL = 2;
  const gPAYMENT_METHOD_COL = 3;
  const gSO_LUONG_SP_COL = 4;
  const gTONG_TIEN_COL = 5;
  const gNGAY_DAT_HANG_COL = 6;
  const gACTION_COL = 7;

  var gStt = 1;
  var gOrderId = 0;

  var gOrderTable = $("#order-table").DataTable({
    columns: [
      { data: gORDER_COLS[gSTT_COL] },
      { data: gORDER_COLS[gMADH_COL] },
      { data: gORDER_COLS[gHO_TEN_COL] },
      { data: gORDER_COLS[gPAYMENT_METHOD_COL] },
      { data: gORDER_COLS[gSO_LUONG_SP_COL] },
      { data: gORDER_COLS[gTONG_TIEN_COL] },
      { data: gORDER_COLS[gNGAY_DAT_HANG_COL] },
      { data: gORDER_COLS[gACTION_COL] },
    ],
    info: false,
    paging: false,
    searching: false,
    ordering: false,
    columnDefs: [
      {
        targets: gSTT_COL,
        render: function () {
          return gStt++;
        },
      },
      {
        targets: gHO_TEN_COL,
        render: function (data, type, row, meta) {
          var vHoTen = row.firstName + " " + row.lastName;
          return vHoTen;
        },
      },
      {
        targets: gSO_LUONG_SP_COL,
        render: function (res) {
          return res.length;
        },
      },
      {
        targets: gTONG_TIEN_COL,
        render: renderTongTien,
      },
      {
        targets: gNGAY_DAT_HANG_COL,
        render: function (res) {
          return formatDate(res);
        },
      },
      {
        targets: gACTION_COL,
        defaultContent: `
                    <img class="edit-order" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-order" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                `,
      },
    ],
  });
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  onPageLoading();
  $(document).on("click", ".edit-order", function () {
    onBtnEditClick(this);
  });
  $(document).on("click", ".delete-order", function () {
    onBtnDeleteClick(this);
  });

  //nút Cập nhật trên modal
  $(document).on("click", "#btn-update-order", function () {
    onBtnUpdateClick();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm thực thi khi tải trang
  function onPageLoading() {
    loadOrderList();
  }

  //hàm thực thi khi nhấn nút cập nhật trên modal
  function onBtnUpdateClick() {
    var vOrderObj = {
      firstName: "",
      lastName: "",
      email: "",
      address: "",
      phone: "",
      methodPayment: "",
      voucherId: "",
    };
    // B1: Thu thập dữ liệu
    getUpdateOrderData(vOrderObj);
    // B2: Validate dữ liệu
    var vIsValidate = validateUpdateOrderData(vOrderObj);
    if (vIsValidate) {
      // B3: update order
      $.ajax({
        url: gBASE_URL + "/orders/" + gOrderId,
        type: "PUT",
        contentType: "application/json",
        data: JSON.stringify(vOrderObj),
        success: function (paramRes) {
          // B4: xử lý front-end
          handleUpdateOrderSuccess();
          console.log(paramRes);
        },
        error: function (paramErr) {
      console.log(paramErr)
          console.log(paramErr.status);
        },
      });
    }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm gọi api để load order list
  function loadOrderList() {
    $.ajax({
      url: gBASE_URL + "/orders",
      type: "GET",
      success: function (res) {
        console.log(res);
        loadOrdersToTable(res);
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText);
      },
    });
  }

  //hàm hiển thị order list lên table
  function loadOrdersToTable(paramRes) {
    gOrderTable.clear();
    gOrderTable.rows.add(paramRes);
    gOrderTable.draw();
  }

  //hàm render tổng tiền
  function renderTongTien(paramFoodObjArray) {
    var vTongTien = 0;
    for (var bI = 0; bI < paramFoodObjArray.length; bI++) {
      var vPriceString = paramFoodObjArray[bI].price;
      vTongTien += parseFloat(vPriceString);
    }
    return "$ " + vTongTien;
  }

  //hàm chuyển date thành dd-mm-yyyy
  function formatDate(date) {
    var d = new Date(date),
      month = "" + (d.getMonth() + 1),
      day = "" + d.getDate(),
      year = d.getFullYear();

    if (month.length < 2) month = "0" + month;
    if (day.length < 2) day = "0" + day;

    return [day, month, year].join("-");
  }

  //hàm thực thi khi nhấn nút icon Edit
  function onBtnEditClick(paramBtnElement) {
    var vOrderId = getOrderId(paramBtnElement);
    console.log(vOrderId);
    gOrderId = vOrderId;

    $.ajax({
      url: gBASE_URL + "/orders/" + vOrderId,
      type: "GET",
      success: function (res) {
        loadOrderOnModal(res);
      },
      error: function (ajaxContext) {
        alert(ajaxContext.responseText);
      },
    });
  }

  //hàm thực thi khi nhấn nút icon Delete
  function onBtnDeleteClick(paramBtnElement) {
    var vOrderId = getOrderId(paramBtnElement);
    console.log(vOrderId);
    gOrderId = vOrderId;

    $("#delete-confirm-modal").modal("show");

    $(document).on("click", "#btn-confirm-delete-user", function () {
      $.ajax({
        url: gBASE_URL + "/orders/" + gOrderId,
        type: "DELETE",
        success: function (res) {
          alert("Xóa thành công");
          loadOrderList();
          $("#delete-confirm-modal").modal("hide");
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        },
      });
    });
  }

  //hàm lấy id order dựa vào nút đã ấn
  function getOrderId(paramBtn) {
    var vRow = $(paramBtn).parents("tr");
    var vRowData = gOrderTable.row(vRow).data();
    return vRowData.id;
  }

  //hàm hiển thị thông tin order đã chọn lên modal
  function loadOrderOnModal(paramRes) {
    $("#update-order-modal").modal("show");

    $("#input-update-ho-dem").val(paramRes.firstName);
    $("#input-update-ten").val(paramRes.lastName);
    $("#input-update-email").val(paramRes.email);
    $("#input-update-phone").val(paramRes.phone);
    $("#input-update-address").val(paramRes.address);
    $("#select-update-payment-method").val(paramRes.methodPayment);
    $("#input-update-ma-giam-gia").val(paramRes.voucherId);

    //lấy phần trăm giảm giá
    if (paramRes.voucherId != "") {
      var vQueryVoucherCode = {
        voucherCode: paramRes.voucherId,
      };

      var vSearchParams = new URLSearchParams(vQueryVoucherCode);
      $.ajax({
        url: gBASE_URL + "/vouchers" + "?" + vSearchParams.toString(),
        type: "GET",
        success: function (res) {
          console.log(res);
          if (jQuery.type(res) === "undefined") {
            var vPhanTramGG = res[0].discount;
            $("#span-update-phan-tram-giam-gia").html(vPhanTramGG + "%");
          }
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    }
  }

  //hàm thu thập dữ liệu trên modal Sửa
  function getUpdateOrderData(paramOrderObj) {
    paramOrderObj.firstName = $("#input-update-ho-dem").val().trim();
    paramOrderObj.lastName = $("#input-update-ten").val().trim();
    paramOrderObj.email = $("#input-update-email").val().trim();
    paramOrderObj.phone = $("#input-update-phone").val().trim();
    paramOrderObj.address = $("#input-update-address").val().trim();
    paramOrderObj.methodPayment = $("#select-update-payment-method").val();
    paramOrderObj.voucherId = $("#input-update-ma-giam-gia").val().trim();
  }

  // hàm validate data order update
  function validateUpdateOrderData(paramOrderObj) {
    if (paramOrderObj.email === "") {
      alert("Email cần nhập");
      return false;
    }
    if (validateEmail(paramOrderObj.email) === false) {
      alert("Email nhập vào không đúng định dạng!");
      return false;
    }

    if (paramOrderObj.phone === "") {
      alert("Phone cần nhập");
      return false;
    }
    if (validatePhone(paramOrderObj.phone) === false) {
      alert("Số điện thoại nhập vào không đúng định dạng!");
      return false;
    }

    return true;
  }

  // hàm kiểm tra email đúng định dạng ko?
  function validateEmail(paramEmail) {
    var vValidRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    if (paramEmail.match(vValidRegex)) {
      return true;
    } else {
      return false;
    }
  }

  //hàm kiểm tra số điện thoại
  function validatePhone(paramPhone) {
    // Số điện thoại phải nhập là số, có dấu + hoặc số 0 ở đầu; độ dài từ 10 đến 12 ký tự

    if (isNaN(paramPhone)) {
      return false;
    }

    if (paramPhone.charAt(0) != "0" && paramPhone.charAt(0) != "+") {
      return false;
    }

    if (paramPhone.length < 10 || paramPhone.length > 12) {
      return false;
    }

    return true;
  }

  // hàm xử lý hiển thị khi sửa order thành công
  function handleUpdateOrderSuccess() {
    alert("Sửa order thành công!");
    loadOrderList();
    resertUpdateOrderForm();
    $("#update-order-modal").modal("hide");
  }

  // hàm xóa trắng form update order
  function resertUpdateOrderForm() {
    $("#input-update-ho-dem").val("");
    $("#input-update-ten").val("");
    $("#input-update-email").val("");
    $("#input-update-phone").val("");
    $("#input-update-address").val("");
    $("#select-update-payment-method").val("Paypal");
    $("#input-update-ma-giam-gia").val("");
    $("#span-update-phan-tram-giam-gia").html("0%");
  }
</script>
